grammar Texinfo;
// ( cd /Users/perm/git/spider/se.sics.sicstus.ide/src/se/sics/sicstus/antlr4/texinfo && rm -rf /tmp/foo && mkdir /tmp/foo && java -jar ~/Downloads/www.antlr.org/antlr-4.9.3-complete.jar -o /tmp/foo Texinfo.g4 && javac -cp ~/Downloads/www.antlr.org/antlr-4.9.3-complete.jar /tmp/foo/*.java && for f in ~/sicstus/sicstus4-ghetto/*_text.texi ; do printf '%s\n' "${f}"; printf '\n' | java -cp ~/Downloads/www.antlr.org/antlr-4.9.3-complete.jar:/tmp/foo org.antlr.v4.gui.TestRig Texinfo markup "$f" ; done )

// A variant that is little more than a tokenizer.

markup
:
        ( // FIXME: (Obsolete?) I do not understand why Eol* is needed, but neither Eol, nor Eol+ works for the atanh_text_orig.texi test (which starts with an empty line).
                eol*
                | lines += line
        )
        (
                eol+ lines += line
        )* eol* EOF
;

line
:
        items += item* line_comment?
;

eol
:
        Eol
;

item
:
        command_item
        | brace_item
        | text_item
;

command_item
:
        AtCommandName
;

brace_item
:
        SpacedLeftBrace
        (
                eol // Eol
                | item
        )* '}'
;

AtCommandName
:
        '@' GENERIC_COMMAND_NAME // COMMAND_NAME

;

SpacedLeftBrace
:
        ' '* // FIXME: ### DO NOT PUSH ### Should probably not ignore spaces before braces "@code {foo}" is not valid syntax.
         '{'
;

fragment
GENERIC_COMMAND_NAME
:
        SYMBOL_COMMAND_NAME
        | ALPHABETIC_COMMAND_NAME
;

// Original definition, that overlaps with the @c and @comment tokens.
fragment
XALPHABETIC_COMMAND_NAME
:
        [a-z_A-Z] [a-z_A-Z0-9]*
;

// The Texinfo 6.8 manual is unclear about the exact syntax (using the undefined "word").
// There are also user defined macros, and those can use "dash" in makeinfo (but _not_ underscore),
// however "For a macro to work consistently with TeX, macroname must consist entirely of letters".
// Long story short, we could probably disallow underscore "_" in the below rule.
//
fragment
ALPHABETIC_COMMAND_NAME
:
        ([abd-z_A-Z] [a-z_A-Z0-9]*) // Does not start with "c"
        |
        ([c] [a-np-z_A-Z0-9]+ [a-z_A-Z0-9]*) // Starts with "c" followed by not "o".
        |
        ([c] [o] [a-ln-z_A-Z0-9]+ [a-z_A-Z0-9]*) // Starts with "co" followed by not "m".
        |
        ([c] [o] [m] [a-ln-z_A-Z0-9] [a-z_A-Z0-9]*) // Starts with "com" followed by not "m".
        |
        ([c] [o] [m] [m] [a-df-z_A-Z0-9] [a-z_A-Z0-9]*) // Starts with "comm" followed by not "m".
        |
        ([c] [o] [m] [m] [e] [a-mo-z_A-Z0-9] [a-z_A-Z0-9]*) // Starts with "comme" followed by not "n".
        |
        ([c] [o] [m] [m] [e] [n] [a-su-z_A-Z0-9] [a-z_A-Z0-9]*) // Starts with "commen" followed by not "t".
        |
        ([c] [o] [m] [m] [e] [n] [t] [a-z_A-Z0-9]+) // Starts with "comment" followed by more identifier chars.
;


Line_comment
:
// Update: The priority-to-string-literals idea does not fully work. In particular,
// parsing "@c\n" will treat the "@c" as a AtCommandName in the original 
// definition of ALPHABETIC_COMMAND_NAME (i.e. "[a-z_A-Z] [a-z_A-Z0-9]*"). Now we ensure the tokenizer
// cannot match @c or @comment as an AtCommandName, and avoid the ambiguity.
// INCORRECT: Note: See ANTLR book (or <https://stackoverflow.com/a/59944329>) for how ANTLR gives priority to string literals, like 'comment',
// over explicit lexical rules, like AtCommandName (above). Therefore, it is not a problem that AtCommandName also matches
// '@c' and '@comment', the literal 'c' and 'comment' here will get priority.
        '@'
        (
                'c'
                | 'comment'
        )
        (
                SPACE
                (
                        ~[\r\n]
                )*
        )?
;

fragment
SYMBOL_COMMAND_NAME
:
        SPACE
        | TAB
        | EOL
        | '!'
        | '"'
        | '\''
        | '&'
        | '*'
        | ','
        | '-'
        | '.'
        | '/'
        | ':'
        | '='
        | '?'
        | '@'
        | '\\'
        | '^'
        | '`'
        | '{'
        | '}'
        | '~'
;

line_comment
:
        Line_comment
;

Eol
:
        EOL
;

text_item
:
        (
                Space
                | NonSpaceTextChar
        )+
        |
        // The idea is to enforce that quotes are always alone in a text_item, as we can add the special Texinfo commands `` and '' as post-processing.
        (
                Backtick
                |
                Apostrophe
        )
;

Backtick
:
        BACKTICK
;

Apostrophe
:
        APOSTROPHE
;

Space
:
        SPACE
;

fragment
BACKTICK
:
        '`'
;

fragment
APOSTROPHE
:
        '\''
;


fragment
SPACE
:
        ' '
;

fragment
TAB
:
        '\t'
;

fragment
EOL
:
        '\r'? '\n'
;

NonSpaceTextChar
:
        ~[`'@{}\r\n ]
;


